package gitpb

// todo: autogen this
// functions to import and export the protobuf

import (
	"google.golang.org/protobuf/encoding/protojson"
	"google.golang.org/protobuf/encoding/prototext"
	"google.golang.org/protobuf/proto"
)

// human readable JSON
func (r *Repo) FormatJSON() string {
	return protojson.Format(r)
}

// apparently this isn't supposed to be used?
// https://protobuf.dev/reference/go/faq/#unstable-text
// this is a shame because this is much nicer output than JSON Format()
func (r *Repo) FormatTEXT() string {
	return prototext.Format(r)
}

// marshal json
func (r *Repo) MarshalJSON() ([]byte, error) {
	return protojson.Marshal(r)
}

// unmarshal
func (r *Repo) UnmarshalJSON(data []byte) error {
	return protojson.Unmarshal(data, r)
}

// marshal to wire
func (r *Repo) Marshal() ([]byte, error) {
	return proto.Marshal(r)
}

// unmarshal from wire
func (r *Repo) Unmarshal(data []byte) error {
	return proto.Unmarshal(data, r)
}
